unit learn_au;
{
     "Learning".
      fmAuthor.

  (C) 05/07/2001, Fwcs Corporation
}


{  }
interface


{   }
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;


{    }
type
  TfmAuthor = class(TForm)
    gbAuthor: TGroupBox;
    mmAuthor: TMemo;
    gbAutImg: TGroupBox;
    imPhSeES: TImage;
    pbVisia1: TPaintBox;
    procedure imPhSeESClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure Draw3D;            //  
//procedure Func2arg;          //   
//procedure PlotZbuf;          //     Z-
//procedure p6000;             //  
//procedure p7000;             //  
 {     -    }
//procedure TfmAuthor.imPhSeESClick(Sender: TObject);
 {     -  }
//procedure TfmAuthor.FormDeactivate(Sender: TObject);
 {     }
//procedure TfmAuthor.FormActivate(Sender: TObject);


{   }
var
  fmAuthor: TfmAuthor;         //     

 { 3D-}
  xmin, ymin: Extended;        //  
  xmax, ymax: Extended;        //   
  nx:Integer;                  //     X
  ny:Integer;                  //     Y
  xh:Extended;                 //     X
  yh:Extended;                 //     Y
  scale:Extended;              //  
  zscale:Extended;             //    Z
  zbuf:array[1..2048] of Integer;  // Z-   
  x:Extended;                  // 
  y:Extended;                  //  
  z :Extended;                 //   
  x1:Extended;                 // 
  y1:Extended;                 //  
  xt:Integer;                  //   X
  yt:Integer;                  //   Y
  dx:Integer;                  //  X
  dy:Integer;                  //  Y
  xold:Integer;                //    X
  yold:Integer;                //    Y


{   }
implementation


{   }
uses learn_01;

{$R *.DFM}


{   }
procedure Draw3D;
label  lpx1,lpy1, lpx2,lpy2;   // 
var  i:Integer;                //  


{    }
 procedure Func2arg;
 var
  r : Extended;        //  
  v : Extended;        //  sin2r
 begin
 with fmAuthor, pbVisia1, Canvas do begin
  r:=sqrt(x*x+y*y);
  if (r<0.00001) then v:=1
                 else v:=(sin(r))/r;
  z:=v*zscale*( abs(TskTimer[17]-200)-100 )/50;
  xt:=Round( (Width/2)+sqrt(3)*(y1-x1)/2 );
  yt:=Round( (Height/2)+z-(y1+x1)/2 );
 end; // with
end; // Func2arg


{     Z- }
procedure PlotZbuf;
begin
  if (yt>zbuf[xt+1]) then
   begin
    zbuf[xt+1]:=yt;
    with fmAuthor, pbVisia1, Canvas do
      Pixels[xt,Height-yt]:=clBlack;
  end;
end;


{   }
 procedure p6000;
 var i:Integer;
  begin
    if (dy<0)
    then                       // p6100
     begin
      for i:=dy to 0 do
       begin
        xt:=xold+Round(i*dx/dy);
        yt:=yold+i;
        PlotZbuf;
       end;
      xold:=xold+dx;  yold:=yold+dy;
     end
    else                       // p6010
     begin
      for i:=0 to dy do
       begin
        xt:=xold+Round(i*dx/dy);
        yt:=yold+i;
        PlotZbuf;
       end;
      xold:=xt; yold:=yt;
     end;
  end; // p6000


{   }
procedure p7000;
  var i:Integer;
  begin
    if (dx<0)
    then                       // p7100
     begin
      for i:=dx to 0 do
       begin
        xt:=xold+i;
        yt:=yold+Round(i*dy/dx);
        PlotZbuf;
       end;
      xold:=xold+dx;  yold:=yold+dy;
     end
    else                       // p6010
     begin
      for i:=0 to dx do
       begin
        xt:=xold+i;
        yt:=yold+Round(i*dy/dx);
        PlotZbuf;
       end;
      xold:=xt; yold:=yt;
     end;
  end; // p7000


{    }
begin
with fmAuthor, pbVisia1, Canvas do begin
 {    }
  Pen.Color   := clBlack;
  Brush.Color := clWhite;
  Rectangle(0, 0, Width, Height);

 {   }
  xmin:=-10; ymin:=-10;
  xmax:=10; ymax:=10;
  nx:=19; ny:=19;
  xh:=(xmin-xmax)/nx; yh:=(ymin-ymax)/ny;
  scale:=Width/sqrt(3)*2/((xmax-xmin)+(ymax-ymin));
  zscale:=40;

 {   }
  for i:=1 to Width do zbuf[i]:=0;
      y:=ymax;
lpy1: y1:=y*scale;
      x:=xmax;
lpx1: x1:=x*scale;

      Func2arg;
      if (x=xmax)
      then
       begin  xold:=xt; yold:=yt;  end
      else
       begin
        dy:=yt-yold; dx:=xt-xold;
        if (abs(dy)>=abs(dx))  then p6000 else p7000;
       end;

      x:=x+xh; if (x>=xmin) then goto lpx1;
      y:=y+yh; if (y>=ymin) then goto lpy1;

 {   }
  for i:=1 to Width do zbuf[i]:=0;
      x:=xmax;
lpx2: x1:=x*scale;
      y:=ymax;
lpy2: y1:=y*scale;

      Func2arg;

      if (y=ymax)
      then
       begin  xold:=xt; yold:=yt;  end
      else
       begin
        dy:=yt-yold; dx:=xt-xold;
        if (abs(dy)>=abs(dx))  then p6000 else p7000;
       end;

      y:=y+yh; if (y>=ymin) then goto lpy2;
      x:=x+xh; if (x>=xmin) then goto lpx2;
end; // with
end; // Draw3D


{     -    }
procedure TfmAuthor.imPhSeESClick(Sender: TObject);
begin
  TskTimer[17]:=1;             //   
  imPhSeES.Visible:=False;     //  
  pbVisia1.Visible:=True;      //  
end;


{     -  }
procedure TfmAuthor.FormDeactivate(Sender: TObject);
begin
  TskTimer[17]:=0;             //  
  pbVisia1.Visible:=False;     //  
  imPhSeES.Visible:=True;      //  
end;


{     }
procedure TfmAuthor.FormActivate(Sender: TObject);
var
  OneStr : String;
  FilVar : TextFile;
begin
  AssignFile(FilVar, fmMnForm.edAdHlAu.Text);
  try
    ReSet(FilVar);
  except
    Exit;
  end;

  mmAuthor.Visible:=False;
  mmAuthor.Lines.Clear;
  while (not EOF(FilVar)) do
   begin
    ReadLn(FilVar, OneStr);
    mmAuthor.Lines.Add(OneStr);
   end;
  CloseFile(FilVar);
  mmAuthor.Visible:=True;
end;

end.
