unit learn_h2;
{
     "Learning".
      fmHlpLrn.

  (C) 10/08/2001, Fwcs Corporation
}


{  }
interface


{   }
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;


{    }
type
  TfmHlpLrn = class(TForm)
    gbLearnM: TGroupBox;
    mmLearn: TMemo;
    gbLearnC: TGroupBox;
    bbH2prnt: TBitBtn;
    bbH2quit: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure bbH2prntClick(Sender: TObject);
    procedure bbH2quitClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


{   }
var
  fmHlpLrn: TfmHlpLrn;


{   }
implementation

uses learn_01;

{$R *.DFM}


{     }
procedure TfmHlpLrn.FormActivate(Sender: TObject);
var
  OneStr : String;
  FilVar : TextFile;
begin
  AssignFile(FilVar, fmMnForm.edAdHlLn.Text);
  try
    ReSet(FilVar);
  except
    Exit;
  end;

  mmLearn.Visible:=False;
  mmLearn.Lines.Clear;
  while (not EOF(FilVar)) do
   begin
    ReadLn(FilVar, OneStr);
    mmLearn.Lines.Add(OneStr);
   end;
  CloseFile(FilVar);
  mmLearn.Visible:=True;
end;


{  [ ] }
procedure TfmHlpLrn.bbH2prntClick(Sender: TObject);
begin
  bbH2prnt.Enabled:=False;     //    
  PrnRus(mmLearn.Lines);       //   
  bbH2prnt.Enabled:=True;      //    
end;


{  [ ] }
procedure TfmHlpLrn.bbH2quitClick(Sender: TObject);
begin
  fmHlpLrn.Hide;
end;

end.
