//include file "learn_te.pas";
{
     "Learning".
     "".

  (C) 09/08/2001, Fwcs Corporation
}


{    }
procedure SelTheme;
var
  ss    :String;
  separ :Integer;
begin
  with fmMnForm do
   begin
    NumTheme:=liThemes.ItemIndex;
 if (NumTheme>=0) then begin
    ss:=lhThemes.Items[NumTheme];
    separ:=pos(edAdPrLs.Text,ss);
    if (separ=0)
    then MessageDlg('      ',
                    mtWarning, [mbOk], 0)
    else
     begin
      StrTheme:=liThemes.Items[NumTheme];  //   
      FilTheme:=KilSpace(copy(ss, 1, separ-1));  //  
      edCurThm.Text:=StrTheme;             //  
      edCurFil.Text:=FilTheme;             //     
      LoadThem(FilTheme);                  //   
      end;  { separ present }
 end;       { select theme }
   end;     { with fmMnForm }
end; // SelTheme


{     }
procedure TfmMnForm.liThemesDblClick(Sender: TObject);
begin
  SelTheme;
end;


{     }
procedure TfmMnForm.liThemesKeyPress(Sender: TObject; var Key: Char);
begin
  if ( (Ord(Key)=13) or (Ord(Key)=32) ) then  SelTheme;
end;


{     []    }
procedure TfmMnForm.btTmLearClick(Sender: TObject);
begin
  BegLearn;                    //    
end;


{     []   }
procedure TfmMnForm.btTmExamClick(Sender: TObject);
begin
  BegExamn;                    //    
end;


{  [  ] }
procedure TfmMnForm.btNewThmClick(Sender: TObject);
var
  fname :String;
begin
  if odOpenTm.Execute and FileExists(odOpenTm.FileName) then
   begin
    fname := odOpenTm.FileName;
    StrTheme:='';  //   
    FilTheme:=fname;                   //     
    edCurThm.Text:=StrTheme;           //  
    edCurFil.Text:=FilTheme;           //     
    edCurFil.SelectAll;                //    
    LoadThem(FilTheme);                //   
   end;
end; // TfmMnForm.btNewThmClick


{   }
procedure TfmMnForm.btTmRegTClick(Sender: TObject);
label
  lp0;
var
  f_lst: Integer;              //   'themes.lst' ()
  ss   : String;               //  
begin
  gbCtrThm.Visible:=False;     //    

 {    ,    }
  f_lst := FileOpen(edAdFlTm.Text, fmOpenWrite or fmShareDenyNone);
  if (f_lst<=0) then goto lp0;

  FileSeek(f_lst, 0,2);        //     
  ss:=edCurFil.Text+' '+edAdPrLs.Text+' '+edCurThm.Text;
  SavStr(f_lst, ss);           //   ,    

lp0: FileClose(f_lst);         //   
     ListThem;                 //   
     gbCtrThm.Visible:=True;   //    
end; // TfmMnForm.btTmRegTClick


{   }
procedure TfmMnForm.btTmDelTClick(Sender: TObject);
begin
  if (liThemes.ItemIndex>=0) then  // ,    
   begin
    fmMnForm.Hide;                 //   
    fmKilThm.Show;                 //    
   end;
end; // TfmMnForm.btTmDelTClick


{    "" }
procedure TfmMnForm.btTmHelpClick(Sender: TObject);
begin
  fmHlpThm.Show;               //    
end;

